﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Public list_Read As List
	Public  ReadJsonList As List
	Public ParamMap As Map
	Dim PI As Phone
	Dim pi1 As PhoneId
	Dim Bconv As ByteConverter
End Sub

Sub write_file_setup(data As List, file_name As String,append_data As Boolean)  As ResumableSub
	
	Dim Writer As TextWriter
	
	If append_data=False Then
		Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,False))
	Else
		Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,True))
	End If
	
	Try
		
	For Each info As String In data
			Writer.WriteLine(info)
	Next
							
		Writer.Close
		Return True
	Catch
		ToastMessageShow("Sauvegarde impossible", True)
		Return False
	End Try

End Sub

'***********************Writer Json File*********************************

Sub Write_Json_File(file_name As String,StringMap As String)As ResumableSub
		
	Try
		File.WriteString(File.DirDefaultExternal,file_name,StringMap)
		Return True
	Catch
		ToastMessageShow("Sauvegarde impossible", True)
		Return False
	End Try
	
End Sub

'***********************Reader Json File*********************************

Sub Read_JSONfile(file_name As String) As ResumableSub
	
	Dim JSON As JSONParser
	ReadJsonList.Initialize
	ReadJsonList.Clear
	Try
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, file_name))
		
		ReadJsonList = JSON.NextArray
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
	
		
End Sub

'***********************Reader Json File  Parameters*********************************

Sub Read_JSONfileParameter(file_name As String) As ResumableSub
	
	Dim JSON As JSONParser
	ParamMap.Initialize
	Try
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, file_name))
		
		ParamMap = JSON.NextObject
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
	
		
End Sub

'***********************Reader File*********************************

Sub read_file_setup(file_name As String) As ResumableSub
	Dim reader As TextReader
	list_Read.Initialize
	list_Read.Clear
	
	Try
			
		reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
		list_Read=reader.ReadList
		reader.Close
		Return True
	Catch
		ToastMessageShow("Lecture des paramètres impossible", True)
		Return False
	End Try
	
End Sub


' ***************************Module Encryption**************************

Sub encryt_file (datatoencrypt As String,file_to_encrypt As String)
	
	Dim key(0) As Byte
	Dim data(0) As Byte
	Dim iv(0) As Byte
	
	
	'Log(PI.GetDeviceId)
	
	Dim pwd As String
	If PI.SdkVersion >= 29 Then
		pwd =PI.GetSettings("android_id")
	Else
		pwd  = pi1.GetDeviceId & "F"
	End If
	
	
	
	
	iv=Bconv.StringToBytes(pwd, "UTF8")
		
	Dim kg As KeyGenerator
	Dim c As Cipher
	c.Initialize("AES/CBC/PKCS5Padding")
	c.InitialisationVector = iv
	kg.Initialize("AES")
	kg.KeyFromBytes(iv)
	key = kg.KeyToBytes
		
	data = Bconv.StringToBytes(datatoencrypt, "UTF8")
	data = c.Encrypt(data, kg.Key, True)
		
	'écriture du fichier
	Dim writer As OutputStream=File.OpenOutput(File.DirDefaultExternal, file_to_encrypt,False)
	writer.WriteBytes(data,0,data.Length)
	writer.Close
	
	
	
	
End Sub

' ***************************Module Descryption**************************

Sub decrypt_file (type_file As Int, file_to_decrypt As String)
	
	Dim key(0) As Byte
	Dim data(0) As Byte
	Dim iv(0) As Byte
	Dim datatoencrypt As String=""
	'Log(PI.GetDeviceId)
	
	Dim pwd As String
	If PI.SdkVersion >= 29 Then
		pwd =PI.GetSettings("android_id")
	Else
		pwd  = pi1.GetDeviceId & "F"
	End If
	
	iv=Bconv.StringToBytes(pwd, "UTF8")
		
	Dim kg As KeyGenerator
	Dim c As Cipher
	c.Initialize("AES/CBC/PKCS5Padding")
	c.InitialisationVector = iv
	kg.Initialize("AES")
	kg.KeyFromBytes(iv)
	key = kg.KeyToBytes
		
	' Lecture du fichier
	Dim reader As InputStream = File.OpenInput(File.DirDefaultExternal, file_to_decrypt)
	Dim return_data(reader.BytesAvailable) As Byte
	
	reader.ReadBytes(return_data,0,reader.BytesAvailable)
	data = c.Decrypt(return_data, kg.Key, True)
	datatoencrypt=Bconv.StringFromBytes(data, "UTF8")
	reader.close
	
	'Charge les données dans les variables destinataires
		
	Select Case type_file
		
'		Case Type_Param_init
'			read_data_param=datatoencrypt
'		Case Type_collecte_cx_MMAT
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte.Initialize
'			Main.data_collecte.Clear
'			Main.data_collecte.AddAll(info_file)
'		Case Type_collecte_Foyer_MMAT
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte_foyer.Initialize
'			Main.data_collecte_foyer.Clear
'			Main.data_collecte_foyer.AddAll(info_file)
'		Case Type_collecte_cx_PaME
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte.Initialize
'			Main.data_collecte.Clear
'			Main.data_collecte.AddAll(info_file)
'		Case Type_collecte_Foyer_PaME
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte_foyer.Initialize
'			Main.data_collecte_foyer.Clear
'			Main.data_collecte_foyer.AddAll(info_file)
'		Case Type_Collecte_reg_st
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_reg_st.Initialize
'			Main.data_reg_st.Clear
'			Main.data_reg_st.AddAll(info_file)
'		Case Type_Collecte_hist_7j
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_filehisto7j.Initialize
'			Main.data_filehisto7j.Clear
'			Main.data_filehisto7j.AddAll(info_file)
				
	End Select
	
		
	
End Sub