﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	'#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public connected As Boolean
	Public client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Private const PORT As Int = 9999
	Private working As Boolean = True
	Public return_data_TPlink As Boolean=False
	Private bconv As ByteConverter
	Dim Answer_Data As Boolean=False
	Dim Response_Data_Device As String
	Dim data_loaded As Boolean=False
	Public Statut_Connetion As Int=0
	Dim Noconnected As Int= 0
	Dim Okconnected As Int= 1
	Dim Failconnected As Int= 2
	
	
End Sub

Sub Service_Create
	Answer_Data=False
	'server.Initialize(PORT, "server")
'	ListenForConnections
	
	
End Sub

Private Sub ListenForConnections
'	Do While working
'		server.Listen
'		Wait For Server_NewConnection (Successful As Boolean, NewSocket As Socket)
'		
'		If Successful Then
'			CloseExistingConnection
'			client = NewSocket
'			astream.Initialize(client.InputStream ,client.OutputStream, "astream")
'			UpdateState(True)
'
'		End If
'	Loop
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub ConnectToServer(Host As String)

		Statut_Connetion=Noconnected
		Answer_Data=False
		Log("Trying to connect to: " & Host)
		'CloseExistingConnection
		'Dim client As Socket
		client.Initialize("client")
	
		client.Connect(Host, PORT, 10000)
		
		
		Wait For Client_Connected (Successful As Boolean)
	
		Try
			If Successful Then
				Statut_Connetion= Okconnected
				astream.Initialize(client.InputStream, client.OutputStream, "astream")
				UpdateState (True)
			Else
				Statut_Connetion= Failconnected
				Log("Failed to connect: " & LastException)
				ToastMessageShow("Echec de connexion",True)
			End If
		Catch
			Log(LastException)
		End Try
	
	
End Sub

Public Sub Disconnect
	Log("Disconnect Astream")
	CloseExistingConnection
End Sub

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	
	If client.IsInitialized Then client.Close
	UpdateState (False)
End Sub

Sub UpdateState (NewState As Boolean)
	connected = NewState
	
	
	
	' mise à jour IU
	If Main.GatewayInterface=False Then ' IU de la Gateway. toujours à true pourl'interface HH
		If Main.IU_Setup_Power_connected <> Null Then
			CallSubDelayed(Main.IU_Setup_Power_connected, "SetState")
	
		End If
	End If
	
	
	'CallSubDelayed(Main, "CallBack_Connected")
	
	
	' Appel de la fonction envoi de la requête de commande
	CallSubDelayed(Scan_Power,"state_connexion")
End Sub

Sub AStream_Error
	UpdateState(False)
End Sub

Sub AStream_Terminated
	UpdateState(False)
End Sub

Sub AStream_NewData (Buffer() As Byte)
	'CallSub2(Main, "NewData", Buffer)
	return_data_TPlink=True
	
		NewData(Buffer)
End Sub

Sub NewData (data() As Byte)
	
	Dim key As Int=171 'Clé première de décodage
	
	Dim data_byte_decrypted As Int
	Dim pos As Int=0
		
	
	Dim message As String=""
	For pos = 4 To data.Length-1
			
		data_byte_decrypted=Bit.Xor(Bit.And(data(pos), 0xFF),key) 'Mask FF pour être en LittleEndian
		Dim byte1(1) As Byte
		byte1(0)=data_byte_decrypted
		
		Dim carac As String = bconv.StringFromBytes(byte1,"ASCII")
		key=data(pos)
		message=message & carac
		
	Next
	Log(message)
	Response_Data_Device=message
	
	If message.Contains(Chr(34) & "err_code" & Chr(34) & ":0") Then
		Answer_Data=True
	Else
		Answer_Data=False
			
	End If
	' mise à jour IU
	
	If Main.GatewayInterface=False Then
	
		If Main.IU_Setup_Power_connected <> Null Then
			CallSubDelayed(Main.IU_Setup_Power_connected, "SetState_Answer_data")
		End If
		
	Else If Main.main_actif=True Then 'IU de la Gateway. toujours à true pourl'interface HH
		CallSubDelayed(Main, "SetState_Answer_data")
	End If
		
		
			
		
	
		
	
	
	data_loaded =True
	'CallSubDelayed(Main, "SetState_Answer_data")
	'CallSubDelayed(Callback,"SetState_Answer_data")
End Sub

Public Sub SendData (data() As Byte)
	
	If connected Then astream.Write(data)
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	client.Close
	'server.Close
End Sub



