﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10.7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Private i As Intent
	Private managerBLE As BleManager2
	Private admin As BluetoothAdmin
	Public BluetoothState As Boolean=True
	Public BluetoothState_off As Boolean=False
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public bc As ByteConverter
	Public SharedFolder As String
	
	Public InstallOk As Boolean=False
	
	Dim Service_BLE As String ="3e135142-654f-9090-134a-a6ff5bb77046"
	Private Send_Command_BLE As String ="3fa4585a-ce4a-3bad-db4b-b8df8179ea09"
	Private Notify_BLE As String="d0e8434d-cd29-0996-af41-6c90f4e0eb2a"
	
	Private Event_Type As Int
	Private Event_Search_BLE As Int=0
	Private Event_Connect_BLE As Int =1
	Private Event_Read_Temp_BLE As Int=2
	Private Event_Read_Mode_BLE As Int=3
	Private Event_Read_Boost_BLE As Int=4
	Private Event_Read_Statut_Key_BLE As Int=5
	Private Event_Read_Statut_Vanne As Int=6
	
	Private ServiceBeewi As String="a8b3ff00-4834-4051-89d0-3de95cddd318"
	Private BeewiSetPowerOnOff As String="a8b3ff04-4834-4051-89d0-3de95cddd318"
	
	Private TypeDevice As Int
	
	Private Sensor, BLEPower, BLEThermos, WifiPower As Int
	
	Sensor= 1
	BLEPower=2
	BLEThermos=3
	WifiPower=4
	
	Private ModelSensor As String=""
	Private oompteur_sensor As String=""
	Private ListDevice As List
	Dim Id_sensor As String
	Dim Https_Transfert1 As HttpJob
	Private FindSensor As Boolean=False
	Private Macaddress_BLE As String
	Private jg As JSONGenerator
	Private phone1 As Phone
	
End Sub

Sub Service_Create
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
	If i.IsInitialized=False Then
		i.Initialize("android.settings.BLUETOOTH_SETTINGS", "")
		i.Initialize("android.settings.LOCATION_SOURCE_SETTINGS","")
		StartActivity(i)
	End If
	
	
		
	admin.Initialize("admin")
		
	Https_Transfert1.Initialize("",Me)
	ListDevice.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	ListDevice.Clear
	Macaddress_BLE=""
	'wait for (Param.Read_JSONfile(Collecte_data_sensor.Json_file_Setup)) complete  (result As Boolean)
	FindSensor=False
	StartScan
End Sub

Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
	
	Log("state changed: " & NewState)
	BluetoothState = NewState = admin.STATE_ON
	BluetoothState_off = NewState = admin.STATE_OFF
	
	If BluetoothState=True Then 'Lance le scan après avoir démarré le Bluetooth
		StartScan
	else If BluetoothState_off = True Then
		admin.Enable
	End If
	
End Sub



Public Sub ReadData
	For Each s As String In ConnectedServices
		managerBLE.ReadData(s)
	Next
End Sub

Public Sub Disconnect
	managerBLE.Disconnect
	managerBLE_Disconnected
End Sub

Sub managerBLE_StateChanged (State As Int)
	Select State
		Case managerBLE.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case managerBLE.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case managerBLE.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	
End Sub

Sub managerBLE_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	
	If Collecte_data_sensor.TypeSensor =True Then
		
		If Collecte_data_sensor.ProgSensorType=Name Then
			FindSensor=True
		End If
		
		If FindSensor=True Then
			ListDevice.Add("Thermomètre Xiaomi" & ";" & Id)
			Macaddress_BLE=Id
			managerBLE.StopScan
			wait for (UpdateorCreateJsonSetup) complete (resultFile As Boolean)
			InstallOk=resultFile
			StopService(Me)
		End If
		
	End If
		
End Sub

Sub UpdateorCreateJsonSetup As ResumableSub
	
	Private Size As Int=0
	
	If Param.ReadJsonList.IsInitialized=True Then
		Size  = Param.ReadJsonList.Size
	Else
		Param.ReadJsonList.Initialize
	End If
	 
	Private DataSensorMap As Map
	Private SensorMap As Map
	DataSensorMap.Initialize
	SensorMap.Initialize
	
	'************* JSON Builder****************
	DataSensorMap.Put("Localisation",Collecte_data_sensor.Location)
	DataSensorMap.Put("SensorMacAddress",Macaddress_BLE)
	DataSensorMap.Put("MaxTemp","18")'Temp Max . 18°C par défaut
	DataSensorMap.Put("DeviceMacAddress","")
	DataSensorMap.Put("PowerIP","")
	DataSensorMap.Put("Type","") ' Type device
	DataSensorMap.Put("Pilote",0) 'Pilotage oui/non
	DataSensorMap.Put("Control_Type",0) ' Manuel ou limitation
	DataSensorMap.Put("SetTemp","") ' Set Temp
	
	SensorMap.Put("Pilote " & (Size + 1),DataSensorMap)
	Param.ReadJsonList.Add(SensorMap)
	
	jg.Initialize2(Param.ReadJsonList)
	
		
	Wait For (Param.Write_Json_File(Collecte_data_sensor.Json_file_Setup,jg.ToPrettyString(4))) complete (resultFile As Boolean)
	
	Return resultFile
	

End Sub

Public Sub Connect_BLE
	managerBLE.Connect2(Macaddress_BLE,False)
End Sub

 Sub StartScan
	managerBLE.Initialize("managerBLE")
	
	managerBLE.scan2(Null,False)
	
	If managerBLE.State <> managerBLE.STATE_POWERED_ON Then
		Log("Not powered on.")
	End If 
	
	If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		managerBLE.Scan2(Null, False)
	End If
End Sub

'Sub managerBLE_DataAvailable (ServiceId As String, Characteristics As Map)
'	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
'End Sub

Sub managerBLE_Disconnected
	Log("Disconnected")
	connected = False
End Sub

Sub managerBLE_Connected (services As List)
	Log("Connected")
	connected = True
End Sub

'Sub DownloadSetup
'	
'	wait for (Https_Download_File(HTTPS_adressParameters & DirUser & "/" & File_name)) complete (result As Boolean) 'attend le retour du téléchargement
'	
'	If Https_Transfert1.Success Then
'	JobStatus = STATUS_DONE
'		
'		If Agent.type_file=Agent.DATA_SENSOR_FILE Or Agent.type_file=Agent.SETUP_FILE Or Agent.type_file=Agent.INFO_BATTERY Then
'			'Param.read_file_setup(File_name)
'				
'			'Wait For (Param.read_file_setup(File_name)) complete (result As Boolean)
'			wait for (Param.Read_JSONfile(Json_file_Setup)) complete  (result As Boolean)
'				
'		End If
'	End If
'	
'End Sub
'
'Sub Https_Download_File(Link As String) As ResumableSub
'	
'	JobStatus= STATUS_Download_WORKING
'	
'	If Agent.type_file= Agent.ConfigAccount Then
'		Https_Transfert1.Username = HTTPS_LoginOne
'		Https_Transfert1.Password = HTTPS_PwdOne
'	Else
'		Https_Transfert1.Username = HTTPS_LoginOneUser
'		Https_Transfert1.Password = HTTPS_PwdOneUser
'	End If
'	
'	If NetworkOk=True Then
'		Try
'			Log("Download : " & Link)
'			Https_Transfert1.Download(Link)
'		
'			Wait For (Https_Transfert) JobDone Https_Transfert
'			If Https_Transfert1.Success Then
'				Dim out As OutputStream = File.OpenOutput(File.DirDefaultExternal,File_name, False)
'				File.Copy2(Https_Transfert1.GetInputStream, out)
'				out.Close '<------ very important
'				Log("Download https Success")
'			Else
'				Log("Download https error")
'				Return Https_Transfert1.Success
'	
'			End If
'			Https_Transfert1.Release
'	
'			Return Https_Transfert1.Success
'		
'		Catch
'			Log(LastException)
'			'End_service
'			Return Https_Transfert1.Success
'		End Try
'	End If
'	
'	
'End Sub
Sub InstallSensor
	
End Sub

Sub Service_Destroy

End Sub
